/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of FD.xs. Do not edit this file, edit FD.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Linux/FD.xs"
#ifndef _GNU_SOURCE
#	define _GNU_SOURCE
#endif
#define GNU_STRERROR_R

#include <string.h>

#include <sys/eventfd.h>
#include <sys/signalfd.h>
#include <sys/timerfd.h>

#define PERL_NO_GET_CONTEXT
#define PERL_REENTR_API 1
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#define die_sys(format) Perl_croak(aTHX_ format, strerror(errno))

#define NANO_SECONDS 1000000000

static NV timespec_to_nv(struct timespec* time) {
	return time->tv_sec + time->tv_nsec / (double)NANO_SECONDS;
}

typedef struct { const char* key; size_t length; int value; } map[];

static map clocks = {
	{ STR_WITH_LEN("monotonic")     , CLOCK_MONOTONIC },
	{ STR_WITH_LEN("realtime")      , CLOCK_REALTIME  },
#ifdef CLOCK_BOOTTIME
	{ STR_WITH_LEN("boottime")      , CLOCK_BOOTTIME  },
#endif
#ifdef CLOCK_REALTIME_ALARM
	{ STR_WITH_LEN("realtime_alarm"), CLOCK_REALTIME_ALARM },
#endif
#ifdef CLOCK_BOOTTIME_ALARM
	{ STR_WITH_LEN("boottime_alarm"), CLOCK_BOOTTIME_ALARM },
#endif
};

static clockid_t S_get_clock(pTHX_ SV* clock, const char* funcname) {
	if (SvROK(clock)) {
		SV* value;
		if (!SvROK(clock) || !(value = SvRV(clock)))
			Perl_croak(aTHX_ "Could not %s: this variable is not a clock", funcname);
		return SvIV(value);
	} else {
		int i;
		const char* clock_name = SvPV_nolen(clock);
		for (i = 0; i < sizeof clocks / sizeof *clocks; ++i) {
			if (strEQ(clock_name, clocks[i].key))
				return clocks[i].value;
		}
		Perl_croak(aTHX_ "No such timer '%s' known", clock_name);
	}
}
#define get_clock(ref, func) S_get_clock(aTHX_ ref, func)

static SV* S_io_fdopen(pTHX_ int fd, const char* classname, char type) {
	PerlIO* pio = PerlIO_fdopen(fd, "r");
	GV* gv = newGVgen(classname);
	SV* ret = newRV_noinc((SV*)gv);
	IO* io = GvIOn(gv);
	HV* stash = gv_stashpv(classname, FALSE);
	IoTYPE(io) = type;
	IoIFP(io) = pio;
	IoOFP(io) = pio;
	sv_bless(ret, stash);
	return ret;
}
#define io_fdopen(fd, classname, type) S_io_fdopen(aTHX_ fd, classname, type)

#define SET_HASH_IMPL(key,value) hv_store(hash, key, sizeof key - 1, value, 0)
#define SET_HASH_U(key) SET_HASH_IMPL(#key, newSVuv(buffer.ssi_##key))
#define SET_HASH_I(key) SET_HASH_IMPL(#key, newSViv(buffer.ssi_##key))

static UV S_get_flag(pTHX_ map flags, size_t map_size, SV* flag_name) {
	int i;
	for (i = 0; i < map_size / sizeof *flags; ++i)
		if (strEQ(SvPV_nolen(flag_name), flags[i].key))
			return flags[i].value;
	Perl_croak(aTHX_ "No such flag '%s' known", SvPV_nolen(flag_name));
}
#define get_flag(map, name) S_get_flag(aTHX_ map, sizeof(map), name)

static map event_flags = {
	{ STR_WITH_LEN("non-blocking")  , EFD_NONBLOCK  },
	{ STR_WITH_LEN("semaphore")     , EFD_SEMAPHORE },
};
#define get_event_flag(name) get_flag(event_flags, name)

static SV* S_new_eventfd(pTHX_ const char* classname, UV initial, int flags) {
	int fd = eventfd(initial, flags);
	if (fd < 0)
		die_sys("Can't open eventfd descriptor: %s");
	return io_fdopen(fd, classname, '|');
}
#define new_eventfd(classname, initial, flags) S_new_eventfd(aTHX_ classname, initial, flags)

static map signal_flags = {
	{ STR_WITH_LEN("non-blocking")  , SFD_NONBLOCK  },
};
#define get_signal_flag(name) get_flag(signal_flags, name)

static SV* S_new_signalfd(pTHX_ const char* classname, const sigset_t* sigmask, int flags) {
	int fd = signalfd(-1, sigmask, flags);
	if (fd < 0)
		die_sys("Can't open signalfd descriptor: %s");
	return io_fdopen(fd, classname, '<');
}
#define new_signalfd(classname, sigset, flags) S_new_signalfd(aTHX_ classname, sigset, flags)

static map timer_flags = {
	{ STR_WITH_LEN("non-blocking")  , TFD_NONBLOCK  },
};
#define get_timer_flag(name) get_flag(timer_flags, name)

static SV* S_new_timerfd(pTHX_ const char* classname, SV* clock, int flags, const char* funcname) {
	clockid_t clock_id = get_clock(clock, funcname);
	int fd = timerfd_create(clock_id, flags);
	if (fd < 0)
		die_sys("Can't open timerfd descriptor: %s");
	return io_fdopen(fd, classname, '<');
}
#define new_timerfd(classname, clock, flags, func) S_new_timerfd(aTHX_ classname, clock, flags, func)

static int S_interrupted(pTHX_ int value) {
	if (value == -1 && errno == EINTR) {
		PERL_ASYNC_CHECK();
		return 1;
	}
	return 0;
}
#define interrupted(value) S_interrupted(aTHX_ value)

#define NEVER (struct timespec) { 0 }

typedef int Fd;

#line 152 "lib/Linux/FD.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 296 "lib/Linux/FD.c"

XS_EUPXS(XS_Linux__FD_eventfd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD_eventfd)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 152 "lib/Linux/FD.xs"
		int i, flags = EFD_CLOEXEC;
#line 307 "lib/Linux/FD.c"
	SV *	RETVAL;
	UV	initial;

	if (items < 1)
	    initial = 0;
	else {
	    initial = (UV)SvUV(ST(0))
;
	}
#line 154 "lib/Linux/FD.xs"
	for (i = 1; i < items; i++)
		flags |= get_event_flag(ST(i));
	RETVAL = new_eventfd("Linux::FD::Event", initial, flags);
#line 321 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD_signalfd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD_signalfd)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "sigmask, ...");
    {
#line 162 "lib/Linux/FD.xs"
		int i, flags = SFD_CLOEXEC;
#line 338 "lib/Linux/FD.c"
	SV *	RETVAL;
	sigset_t *	sigmask;

	if (SvROK(ST(0))) {
		if (!sv_derived_from(ST(0), "POSIX::SigSet")) {
			Perl_croak(aTHX_ "sigmask is not of type POSIX::SigSet");
		} else {
	sigmask = (sigset_t *) SvPV_nolen(SvRV(ST(0)));

		}
	} else if (SvOK(ST(0))) {
		int signo = (SvIOK(ST(0)) || looks_like_number(ST(0))) && SvIV(ST(0)) ? SvIV(ST(0)) : whichsig(SvPV_nolen(ST(0)));
		SV* buffer = sv_2mortal(newSVpvn("", 0));
		sv_grow(buffer, sizeof(sigset_t));
		sigmask = (sigset_t*)SvPV_nolen(buffer);
		sigemptyset(sigmask);
		sigaddset(sigmask, signo);
	} else {
		sigmask = NULL;
	}
;
#line 164 "lib/Linux/FD.xs"
	for (i = 1; i < items; i++)
		flags |= get_signal_flag(ST(i));
	RETVAL = new_signalfd("Linux::FD::Signal", sigmask, flags);
#line 364 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD_timerfd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD_timerfd)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "clock, ...");
    {
#line 172 "lib/Linux/FD.xs"
		int i, flags = TFD_CLOEXEC;
#line 381 "lib/Linux/FD.c"
	SV *	RETVAL;
	SV *	clock = ST(0)
;
#line 174 "lib/Linux/FD.xs"
	for (i = 1; i < items; i++)
		flags |= get_timer_flag(ST(i));
	RETVAL = new_timerfd("Linux::FD::Timer", clock, flags, "timerfd");
#line 389 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Event_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Event_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "classname, initial= 0, ...");
    {
#line 184 "lib/Linux/FD.xs"
		int i, flags = EFD_CLOEXEC;
#line 406 "lib/Linux/FD.c"
	SV *	RETVAL;
	const char *	classname = (const char *)SvPV_nolen(ST(0))
;
	UV	initial;

	if (items < 2)
	    initial = 0;
	else {
	    initial = (UV)SvUV(ST(1))
;
	}
#line 186 "lib/Linux/FD.xs"
		for (i = 2; i < items; i++)
			flags |= get_event_flag(ST(i));
		RETVAL = new_eventfd(classname, initial, flags);
#line 422 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Event_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Event_get)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "eventfd");
    {
#line 194 "lib/Linux/FD.xs"
		uint64_t buffer;
		int ret;
#line 440 "lib/Linux/FD.c"
	UV	RETVAL;
	dXSTARG;
	Fd	eventfd = PerlIO_fileno(IoOFP(sv_2io(SvRV(ST(0)))))
;
#line 197 "lib/Linux/FD.xs"
		do {
			ret = read(eventfd, &buffer, sizeof buffer);
		} while (interrupted(ret));
		if (ret == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't read from eventfd: %s");
		}
		RETVAL = buffer;
#line 456 "lib/Linux/FD.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Event_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Event_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "eventfd, value");
    {
#line 212 "lib/Linux/FD.xs"
		uint64_t buffer;
		int ret;
#line 474 "lib/Linux/FD.c"
	UV	RETVAL;
	dXSTARG;
	Fd	eventfd = PerlIO_fileno(IoOFP(sv_2io(SvRV(ST(0)))))
;
	UV	value = (UV)SvUV(ST(1))
;
#line 215 "lib/Linux/FD.xs"
		buffer = value;
		do {
			ret = write(eventfd, &buffer, sizeof buffer);
		} while (interrupted(ret));
		if (ret == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't write to eventfd: %s");
		}
		RETVAL = value;
#line 493 "lib/Linux/FD.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Signal_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Signal_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "classname, sigmask, ...");
    {
#line 234 "lib/Linux/FD.xs"
		int i, flags = SFD_CLOEXEC;
#line 510 "lib/Linux/FD.c"
	SV *	RETVAL;
	const char *	classname = (const char *)SvPV_nolen(ST(0))
;
	sigset_t *	sigmask;

	if (SvROK(ST(1))) {
		if (!sv_derived_from(ST(1), "POSIX::SigSet")) {
			Perl_croak(aTHX_ "sigmask is not of type POSIX::SigSet");
		} else {
	sigmask = (sigset_t *) SvPV_nolen(SvRV(ST(1)));

		}
	} else if (SvOK(ST(1))) {
		int signo = (SvIOK(ST(1)) || looks_like_number(ST(1))) && SvIV(ST(1)) ? SvIV(ST(1)) : whichsig(SvPV_nolen(ST(1)));
		SV* buffer = sv_2mortal(newSVpvn("", 0));
		sv_grow(buffer, sizeof(sigset_t));
		sigmask = (sigset_t*)SvPV_nolen(buffer);
		sigemptyset(sigmask);
		sigaddset(sigmask, signo);
	} else {
		sigmask = NULL;
	}
;
#line 236 "lib/Linux/FD.xs"
		for (i = 2; i < items; i++)
			flags |= get_signal_flag(ST(i));
		RETVAL = new_signalfd(classname, sigmask, flags);
#line 538 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Signal_set_mask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Signal_set_mask)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, sigmask");
    {
	Fd	fd = PerlIO_fileno(IoOFP(sv_2io(SvRV(ST(0)))))
;
	sigset_t *	sigmask;

	if (SvROK(ST(1))) {
		if (!sv_derived_from(ST(1), "POSIX::SigSet")) {
			Perl_croak(aTHX_ "sigmask is not of type POSIX::SigSet");
		} else {
	sigmask = (sigset_t *) SvPV_nolen(SvRV(ST(1)));

		}
	} else if (SvOK(ST(1))) {
		int signo = (SvIOK(ST(1)) || looks_like_number(ST(1))) && SvIV(ST(1)) ? SvIV(ST(1)) : whichsig(SvPV_nolen(ST(1)));
		SV* buffer = sv_2mortal(newSVpvn("", 0));
		sv_grow(buffer, sizeof(sigset_t));
		sigmask = (sigset_t*)SvPV_nolen(buffer);
		sigemptyset(sigmask);
		sigaddset(sigmask, signo);
	} else {
		sigmask = NULL;
	}
;
#line 244 "lib/Linux/FD.xs"
	if(signalfd(fd, sigmask, 0) == -1)
		die_sys("Couldn't set_mask: %s");
#line 578 "lib/Linux/FD.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__FD__Signal_receive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Signal_receive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
#line 249 "lib/Linux/FD.xs"
		int tmp;
#line 593 "lib/Linux/FD.c"
	struct signalfd_siginfo	RETVAL;
	Fd	fd = PerlIO_fileno(IoOFP(sv_2io(SvRV(ST(0)))))
;
#line 251 "lib/Linux/FD.xs"
		do {
			tmp = read(fd, &RETVAL, sizeof(RETVAL));
		} while (interrupted(tmp));
		if (tmp == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't read from signalfd: %s");
		}
#line 607 "lib/Linux/FD.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    HV* ret = newHV();
	    hv_stores(ret, "signo", newSViv(RETVAL.ssi_signo));
	    hv_stores(ret, "code", newSViv(RETVAL.ssi_code));
	    hv_stores(ret, "errno", newSViv(RETVAL.ssi_errno));
	    hv_stores(ret, "pid", newSVuv(RETVAL.ssi_pid));
	    hv_stores(ret, "uid", newSVuv(RETVAL.ssi_uid));
	    hv_stores(ret, "fd", newSViv(RETVAL.ssi_fd));
	    hv_stores(ret, "tid", newSVuv(RETVAL.ssi_tid));
	    hv_stores(ret, "band", newSVuv(RETVAL.ssi_band));
	    hv_stores(ret, "overrun", newSVuv(RETVAL.ssi_overrun));
	    hv_stores(ret, "trapno", newSVuv(RETVAL.ssi_trapno));
	    hv_stores(ret, "status", newSViv(RETVAL.ssi_status));
	    hv_stores(ret, "value", newSViv(RETVAL.ssi_int));
	    hv_stores(ret, "ptr", newSVuv(PTR2UV(RETVAL.ssi_ptr)));
	    hv_stores(ret, "addr", newSVuv(PTR2UV(RETVAL.ssi_addr)));
	    RETVALSV = newRV_noinc((SV*)ret);
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Timer_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_new)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "classname, clock, ...");
    {
#line 268 "lib/Linux/FD.xs"
		int i, flags = TFD_CLOEXEC;
#line 645 "lib/Linux/FD.c"
	SV *	RETVAL;
	const char *	classname = (const char *)SvPV_nolen(ST(0))
;
	SV *	clock = ST(1)
;
#line 270 "lib/Linux/FD.xs"
		for (i = 2; i < items; i++)
			flags |= get_timer_flag(ST(i));
		RETVAL = new_timerfd(classname, clock, flags, "Linux::FD::Timer->new");
#line 655 "lib/Linux/FD.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Timer_get_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_get_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timerfd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 278 "lib/Linux/FD.xs"
		struct itimerspec value;
#line 674 "lib/Linux/FD.c"
	Fd	timerfd = PerlIO_fileno(IoOFP(sv_2io(SvRV(ST(0)))))
;
#line 280 "lib/Linux/FD.xs"
		if (timerfd_gettime(timerfd, &value) == -1)
			die_sys("Couldn't get_timeout: %s");
		mXPUSHn(timespec_to_nv(&value.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&value.it_interval));
#line 683 "lib/Linux/FD.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__FD__Timer_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "timerfd, new_value, new_interval= NEVER, abstime= FALSE");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 288 "lib/Linux/FD.xs"
		struct itimerspec new_itimer, old_itimer;
#line 701 "lib/Linux/FD.c"
	SV *	RETVAL;
	Fd	timerfd = PerlIO_fileno(IoOFP(sv_2io(SvRV(ST(0)))))
;
	struct timespec	new_value;
	struct timespec	new_interval;
	bool	abstime;

	{
	NV input = SvNV(ST(1));
	new_value.tv_sec  = (time_t) floor(input);
	new_value.tv_nsec = (long) ((input - new_value.tv_sec) * 1000000000);
	}
;

	if (items < 3)
	    new_interval = NEVER;
	else {
	    {
	    NV input = SvNV(ST(2));
	    new_interval.tv_sec  = (time_t) floor(input);
	    new_interval.tv_nsec = (long) ((input - new_interval.tv_sec) * 1000000000);
	    }
;
	}

	if (items < 4)
	    abstime = FALSE;
	else {
	    abstime = (bool)SvTRUE(ST(3))
;
	}
#line 290 "lib/Linux/FD.xs"
		new_itimer.it_value = new_value;
		new_itimer.it_interval = new_interval;
		if (timerfd_settime(timerfd, (abstime ? TIMER_ABSTIME : 0), &new_itimer, &old_itimer) == -1)
			die_sys("Couldn't set_timeout: %s");
		mXPUSHn(timespec_to_nv(&old_itimer.it_value));
		if (GIMME_V == G_ARRAY)
			mXPUSHn(timespec_to_nv(&old_itimer.it_interval));
#line 741 "lib/Linux/FD.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Linux__FD__Timer_receive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_receive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timerfd");
    {
#line 300 "lib/Linux/FD.xs"
		uint64_t buffer;
		int ret;
#line 758 "lib/Linux/FD.c"
	IV	RETVAL;
	dXSTARG;
	Fd	timerfd = PerlIO_fileno(IoOFP(sv_2io(SvRV(ST(0)))))
;
#line 303 "lib/Linux/FD.xs"
		do {
			ret = read(timerfd, &buffer, sizeof buffer);
		} while (interrupted(ret));
		if (ret == -1) {
			if (errno == EAGAIN)
				XSRETURN_EMPTY;
			else
				die_sys("Couldn't read from timerfd: %s");
		}
		RETVAL = buffer;
#line 774 "lib/Linux/FD.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Linux__FD__Timer_clocks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__FD__Timer_clocks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "classname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	classname = ST(0)
;
#line 318 "lib/Linux/FD.xs"
	int i;
#line 795 "lib/Linux/FD.c"
#line 320 "lib/Linux/FD.xs"
	for (i = 0; i < sizeof clocks / sizeof *clocks; ++i)
		mXPUSHp(clocks[i].key, clocks[i].length);
#line 799 "lib/Linux/FD.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Linux__FD); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__FD)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::FD::eventfd", XS_Linux__FD_eventfd);
        newXS_deffile("Linux::FD::signalfd", XS_Linux__FD_signalfd);
        newXS_deffile("Linux::FD::timerfd", XS_Linux__FD_timerfd);
        newXS_deffile("Linux::FD::Event::new", XS_Linux__FD__Event_new);
        newXS_deffile("Linux::FD::Event::get", XS_Linux__FD__Event_get);
        newXS_deffile("Linux::FD::Event::add", XS_Linux__FD__Event_add);
        newXS_deffile("Linux::FD::Signal::new", XS_Linux__FD__Signal_new);
        newXS_deffile("Linux::FD::Signal::set_mask", XS_Linux__FD__Signal_set_mask);
        newXS_deffile("Linux::FD::Signal::receive", XS_Linux__FD__Signal_receive);
        newXS_deffile("Linux::FD::Timer::new", XS_Linux__FD__Timer_new);
        newXS_deffile("Linux::FD::Timer::get_timeout", XS_Linux__FD__Timer_get_timeout);
        newXS_deffile("Linux::FD::Timer::set_timeout", XS_Linux__FD__Timer_set_timeout);
        newXS_deffile("Linux::FD::Timer::receive", XS_Linux__FD__Timer_receive);
        newXS_deffile("Linux::FD::Timer::clocks", XS_Linux__FD__Timer_clocks);

    /* Initialisation Section */

#line 145 "lib/Linux/FD.xs"
	load_module(PERL_LOADMOD_NOIMPORT, newSVpvs("IO::Handle"), NULL);
	av_push(get_av("Linux::FD::Event::ISA" , GV_ADD), newSVpvs("IO::Handle"));
	av_push(get_av("Linux::FD::Signal::ISA", GV_ADD), newSVpvs("IO::Handle"));
	av_push(get_av("Linux::FD::Timer::ISA" , GV_ADD), newSVpvs("IO::Handle"));

#line 856 "lib/Linux/FD.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
